#include "FaultyGPSPlugin.hh"

using namespace gazebo;

GZ_REGISTER_SENSOR_PLUGIN(FaultyGPSPlugin)
FaultyGPSPlugin::FaultyGPSPlugin() {}

FaultyGPSPlugin::~FaultyGPSPlugin() {
    this->parentSensor->DisconnectUpdated(this->connection);
    this->parentSensor.reset();
}

void FaultyGPSPlugin::Load(sensors::SensorPtr _parent, sdf::ElementPtr /*_sdf*/) {
    this->parentSensor = std::dynamic_pointer_cast<sensors::GpsSensor>(_parent);
    
    if (!this->parentSensor)
        gzthrow("FaultyGPSPlugin requires a imu sensor as its parent.");
    
    this->connection = this->parentSensor->ConnectUpdated(std::bind(&FaultyGPSPlugin::OnUpdate, this, this->parentSensor));
    this->updateConnection = event::Events::ConnectWorldUpdateBegin(boost::bind(&FaultyGPSPlugin::OnWorldUpdate, this, _1));
}

void FaultyGPSPlugin::OnUpdate(sensors::GpsSensorPtr _sensor) {
    double r = math::Rand::GetDblUniform();
    if(r > 0.1) {
        _sensor->SetActive(false);
    }
}

void FaultyGPSPlugin::OnWorldUpdate(const common::UpdateInfo & /*_info*/) {
    if(!this->parentSensor->IsActive()) {
        double r = math::Rand::GetDblUniform();
        if(r > 0.995) {
            this->parentSensor->SetActive(true);
        }
    }
}
